(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("./procedure"), require("chalk"), require("neo4j-driver"), require("chai"), require("fs"), require("parse-neo4j"));
	else if(typeof define === 'function' && define.amd)
		define("./data", ["./procedure", "chalk", "neo4j-driver", "chai", "fs", "parse-neo4j"], factory);
	else if(typeof exports === 'object')
		exports["./data"] = factory(require("./procedure"), require("chalk"), require("neo4j-driver"), require("chai"), require("fs"), require("parse-neo4j"));
	else
		root["./data"] = factory(root["./procedure"], root["chalk"], root["neo4j-driver"], root["chai"], root["fs"], root["parse-neo4j"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_67__, __WEBPACK_EXTERNAL_MODULE_68__, __WEBPACK_EXTERNAL_MODULE_69__, __WEBPACK_EXTERNAL_MODULE_92__, __WEBPACK_EXTERNAL_MODULE_93__, __WEBPACK_EXTERNAL_MODULE_104__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 113);
/******/ })
/************************************************************************/
/******/ ({

/***/ 104:
/***/ (function(module, exports) {

module.exports = require("parse-neo4j");

/***/ }),

/***/ 113:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(73);


/***/ }),

/***/ 67:
/***/ (function(module, exports) {

module.exports = require("./procedure");

/***/ }),

/***/ 68:
/***/ (function(module, exports) {

module.exports = require("chalk");

/***/ }),

/***/ 69:
/***/ (function(module, exports) {

module.exports = require("neo4j-driver");

/***/ }),

/***/ 73:
/***/ (function(module, exports, __webpack_require__) {

var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;(function (global, factory) {
    if (true) {
        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [exports, __webpack_require__(69), __webpack_require__(93), __webpack_require__(92), __webpack_require__(68), __webpack_require__(104), __webpack_require__(67)], __WEBPACK_AMD_DEFINE_FACTORY__ = (factory),
				__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
				(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
    } else if (typeof exports !== "undefined") {
        factory(exports, require('neo4j-driver'), require('fs'), require('chai'), require('chalk'), require('parse-neo4j'), require('./procedure'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.neo4jDriver, global.fs, global.chai, global.chalk, global.parseNeo4j, global.procedure);
        global.data = mod.exports;
    }
})(this, function (exports, _neo4jDriver, _fs, _chai, _chalk, _parseNeo4j, _procedure) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.API = exports.Procedure = exports.Neo4jConnection = undefined;

    var _fs2 = _interopRequireDefault(_fs);

    var _chai2 = _interopRequireDefault(_chai);

    var _chalk2 = _interopRequireDefault(_chalk);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    /**
     * Created by keyvan on 8/16/16.
     */

    class Neo4jConnection {
        constructor() {
            var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

            let boltUrl = _ref.boltUrl,
                user = _ref.user,
                password = _ref.password;

            this.queries = {};

            this.driver = _neo4jDriver.v1.driver(boltUrl, _neo4jDriver.v1.auth.basic(user, password));
            const session = this.driver.session();
            this.initialized = session.run('RETURN "Neo4j instance successfully connected."').then(function (result) {
                console.log(_chalk2.default.green((0, _parseNeo4j.parse)(result)));
                session.close();
            }).catch(function (error) {
                console.error(_chalk2.default.red('Error connecting to the Neo4j instance, check connection options'));
                console.log(error);
                throw error;
            });
        }

        addCypherQueryFile(cypherQueryFilePath) {
            this.queries[cypherQueryFilePath] = _fs2.default.readFileSync(cypherQueryFilePath, 'utf8');
        }

        executeCypher(cypherQueryFilePath, queryParams) {
            var _this = this;

            let pathIsQuery = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

            return new Promise(function (resolve, reject) {
                if (!pathIsQuery && !_this.queries[cypherQueryFilePath]) _this.addCypherQueryFile(cypherQueryFilePath);

                let query = cypherQueryFilePath;
                if (!pathIsQuery) query = _this.queries[cypherQueryFilePath];
                const session = _this.driver.session();

                session.run(query, queryParams).then(function (result) {
                    resolve(result);
                    session.close();
                }).catch(function (error) {
                    session.close();
                    error = error.fields ? JSON.stringify(error.fields[0]) : String(error);
                    reject(`error while executing Cypher: ${error}`);
                });
            }).then(_parseNeo4j.parse);
        }

        executeCyphers(cyphers, params) {
            var _this2 = this;

            let results = [];

            let runCyphers = function (session, array, fn) {
                let index = 0;
                return new Promise(function (resolve, reject) {
                    function next() {
                        if (index < array.length) {
                            fn(session, array[index++]).then(next, reject);
                        } else {
                            resolve();
                        }
                    }
                    next();
                });
            };

            let runCypher = function (session, cypher) {
                return session.run(cypher, params).then(function (result) {
                    results.push(result);
                });
            };

            return new Promise(function (resolve, reject) {
                const session = _this2.driver.session();
                runCyphers(session, cyphers, runCypher).then(function () {
                    session.close();
                    resolve(results);
                }, function (error) {
                    session.close();
                    error = error.fields ? JSON.stringify(error.fields[0]) : String(error);
                    reject(`error while executing Cypher: ${error}`);
                });
            }).then(function (results) {
                return results.map(_parseNeo4j.parse);
            });
        }
    }

    class API {
        constructor(neo4jConnection, options) {
            if (typeof options.procedure === 'function') this.invoke = options.procedure;else this.invoke = (0, _procedure.createProcedure)(neo4jConnection, options);

            _chai2.default.assert.typeOf(options.method, 'string');
            _chai2.default.assert.typeOf(options.route, 'string');

            this.method = options.method;
            this.route = options.route;
            this.allowedRoles = options.allowedRoles || [];
            _chai2.default.assert.isArray(this.allowedRoles);
            this.allowedRoles = this.allowedRoles.map(function (role) {
                return role.toLowerCase();
            });
            this.requiresJwtAuthentication = this.allowedRoles.length > 0;
        }
    }

    exports.Neo4jConnection = Neo4jConnection;
    exports.Procedure = _procedure.Procedure;
    exports.API = API;
});

/***/ }),

/***/ 92:
/***/ (function(module, exports) {

module.exports = require("chai");

/***/ }),

/***/ 93:
/***/ (function(module, exports) {

module.exports = require("fs");

/***/ })

/******/ });
});
//# sourceMappingURL=data.js.map